drop table setcpasswd;
drop table fetcpasswd;
drop table elective_prefs;
drop table rollhistory;
drop table gp_electives;
drop table elective;
drop table elective_name;
drop table gp_defaults;
drop table gp;
drop table regconsent;
drop table fac_ad;
drop table registration;
drop table course;
drop table student;
drop table batch;
drop table faculty;
drop table dept;

create table dept 
( constraint pk_dept primary key  (dno),
  dno varchar(5) not null, dname varchar(40));

create table faculty
( constraint pk_fac primary key  (fno) ,
 fno varchar(10), name varchar(40), 
 dno varchar(5) references dept ,
 femail_id varchar(40),
 furl varchar(100)
);

create table batch
( constraint pk_batch primary key (batchno),
batchno varchar(10), dno varchar(5) references dept,
yyyyofentry number(4) not null, programme varchar(10));

create table student
( constraint pk_student primary key (srollno),
srollno varchar(10), sname varchar(21), 
shostel number(2), sroomno number(3), 
batchno varchar(10) references batch,
semail_id varchar(21),scpi number(2),
surl varchar(100));

create table course
( constraint pk_course primary key (cno),
cno varchar(10), cname varchar(20),
ccredits number(3), cslot number(2),
croomno varchar(30), fno varchar(10) references faculty,
dno varchar(5) references dept,
ctype char(1),
curl varchar(100));

create table registration
( constraint pk_registration primary key (srollno,cno),
srollno varchar(10) references student,
cno varchar(10) references course);

create table fac_ad
( constraint pk_fac_ad primary key (fno,batchno),
  constraint fk_fac_ad foreign key(fno) references faculty,
  constraint fk_fac_ad1 foreign key(batchno) references batch,
fno varchar(10) ,
batchno varchar(10) );

create table regconsent
( constraint pk_regconsent primary key (srollno,cno),
srollno varchar(10) references student,
cno varchar(10) references course,
instr_cons number(1), fac_ad_cons number(1));

create table gp
( constraint pk_group primary key (gp_no),
gp_no varchar(10), dno varchar(5) references dept,
sem number(2), programme varchar(10),
constraint uniq unique(dno,sem,programme)
);

create table gp_defaults
(gp_no varchar(10) references gp,
cno varchar(10) references course
);


create table elective_name (
	ename varchar(100),
	eno varchar(10),
	constraint elective_name_pk primary key (eno)
);

create table elective
(eno varchar(10) references elective_name,
cno varchar(10) references course,
constraint pk_elective primary key  (cno)
);


create table gp_electives
(gp_no varchar(10) references gp,
eno varchar(10) references elective_name ,
constraint pk_gp_elective_defaults primary key  (gp_no,eno)
);



create table rollhistory
( srollno varchar(10) references student,
 old_srollno varchar(10)
 );

create table elective_prefs (
 srollno varchar(10) references student,
 eno varchar(10) references elective_name,
 cno varchar(10) references elective(cno),
 prefno integer,
 unique(srollno,eno,prefno));
