package oncore;

import java.sql.*;
import java.lang.*;

/** Generic class to authenticate users. This class doesn't support encrypted
 * passwords for the time being. This class assumes two different tables in
 * the databse for student and faculty.
 */
public class Validator 
{
    // store the connection to the database so that same object can be used to
    // authenticate more than one users.
    private Connection conn;
    
    /** this stores only database connection with the class. 
      * @param con the jdbc database connection
      */
    public Validator(Connection con)
    {
	conn = con;
    }
    
    /** Method to check if the password for a user is correct. This is called
     * by constructor of session before they accept the user by connecting
     * database. Could be easily modified to handle encrypted passwords as
     * well.
     * @param idno user-id for the user. typically a roll number
     * @param passwd password of the user, ecrypted passwords not supported
     * yet.
     * @param isStudent Whether the user is student ( isStudent == true ) or instructor
     * (isStudent == false ).
     * @exception SQLException thrown if we go wrong somewhere while executing
     * database query.
     */
    public boolean isValid(String idno,String passwd,boolean isStudent) 
    throws SQLException
    {
	// create a statement
	Statement stmt = conn.createStatement();

	// query the DB
        String qry;
        if(isStudent)
        {
// #ifdef DEBUG
//            System.err.println(" Trying to validate student \n query is ");
// #endif
            // query on student db to find out whether the password is correct.
	    qry = "select * from setcpasswd" +" where idno = '"
            +idno+"' and password = '" + passwd + "'";
//            System.err.println(qry);
        }
        else
        {
            // query on faculty db to find out whether the password is
            // correct.
            qry = "select * from fetcpasswd" + " where idno = '"
                +idno+"' and password = '" + passwd + "'";
        }
//      System.err.println(qry);
	ResultSet rset = stmt.executeQuery(qry);

        // There indeed is an entry with the given name and password.
        if (rset.next()) { 
            return true;
        }
	// wrong password or probably the user name does not exist in the
        // table.
//      System.err.println( "Oops! Wrong Password!");
	return false;
    }
}

